import { Web } from '@utils/isomorphy';

export default class RPC {
  private mProxyUri: string = '';
  private mDpi: HTMLIFrameElement;

  constructor(proxyUri: string) {
    this.mProxyUri = proxyUri;
    this.mDpi = document.getElementById('anue-dpi') as HTMLIFrameElement;
    if (!this.mDpi) {
      this.mDpi = document.createElement('iframe');
      this.mDpi.setAttribute('id', 'anue-dpi');
      this.mDpi.style.border = 'none';
      this.mDpi.style.position = 'fixed';
      this.mDpi.style.left = '-9999px';
      this.mDpi.style.top = '-9999px';
      this.mDpi.height = '1px';
      this.mDpi.width = '1px';
      document.body.appendChild(this.mDpi);
    }

    window.addEventListener('message', e => {
      if (e.origin.includes('cnyes.com') || e.origin.includes('cnyes.cool')) {
        try {
          const data = JSON.parse(e.data);
          if (data.type === 'gauth') {
            console.log(
              '%c [gauth-rpc] received message ',
              'color: green',
              data
            );
          }
        } catch (ignored) {}
      }
    });

    this.mDpi.addEventListener('load', () => {});
  }

  @Web(null)
  rpcCall = (prefix, ...args) => {
    console.log('[rpc] call %s %o', prefix, args);
    this.mDpi.src = `${this.mProxyUri}/?dpi=${prefix}:${encodeURIComponent(
      args.join(' ')
    )}`;
  };
}
